#include <math.h>
#include <stdio.h>
#include <stdlib.h>

const double warunek = 0.0000000001;

double f1(double x,double y) {
	return x*x+(y-1)*(y-1);
}

double f2(double x, double y) {
	return 100*pow(x*x-y,2)+(1-x)*(1-x);
}

double f3(double x,double y) {
	return 837.9658+x*sin(sqrt(fabs(x)))+y*sin(sqrt(fabs(y)));
}

int main() {
	double punkty[3][2];
	double pS[2];
	double pp[2];
	double ppp[2];
	int min, max;
	double wartmin, wartmax;
	double (*f) (double, double);
	int i;
	double dzielna = 2;
	double ww;
	
	printf("Wybierz funkcje: ");
	scanf("%d", &i);
	
	switch(i) {
		case 1:
			f = f1;
			break;
		case 2:
			f = f2;
			break;
		default:
			f = f3;
	}
	
	printf("Podaj wspolrzedne wektorow startowych: ");
	for (i=0; i<3; i++)
		scanf("%lf %lf", &punkty[i][0], &punkty[i][1]);

	do {
		printf("\nPunkty:\n (%20.20f, %20.20f)\n (%20.20f, %20.20f)\n (%20.20f, %20.20f)\n", punkty[0][0], punkty[0][1], punkty[1][0], punkty[1][1], punkty[2][0], punkty[2][1]);
		printf("Wartosci:\n %20.20f\n %20.20f\n %20.20f\n",f(punkty[0][0],punkty[0][1]),f(punkty[1][0],punkty[1][1]),f(punkty[2][0],punkty[2][1]));

		max = min = 0;
		wartmax=f(punkty[0][0],punkty[0][1]);
		wartmin=wartmax;

		for (i = 1 ; i<3 ; i++) {
    			ww=f(punkty[i][0],punkty[i][1]);
    			if (ww<wartmin) {
				wartmin=ww;
				min=i;
			}
    			if (ww>wartmax) {
				wartmax=ww;
				max=i;
			}
    		}

		if (f(punkty[max][0],punkty[max][1])-f(punkty[min][0],punkty[min][1])<warunek) {
    			printf("ROZWIAZANIE: (%20.20f, %20.20f)\n",punkty[min][0],punkty[min][1]);
    			break;
    		}

		pS[0] = 0;
		pS[1] = 0;
		for (i=0 ; i<3; i++) {
        		pS[0]+=punkty[i][0];
        		pS[1]+=punkty[i][1];
		}
		pS[0] -= punkty[max][0];
		pS[1] -= punkty[max][1];
		pS[0] /= 2;
		pS[1] /= 2;

    		pp[0]=2*pS[0]-punkty[max][0];
    		pp[1]=2*pS[1]-punkty[max][1];
		
		if (f(pp[0],pp[1])<=min && pp[0]>-500 && pp[1]>-500 && pp[0]<500 && pp[1]<500) {
    			ppp[0]=pS[0]+dzielna*(pS[0]-punkty[max][0]);
    			ppp[1]=pS[1]+dzielna*(pS[1]-punkty[max][1]);
    		} else {
    			ppp[0]=pS[0]-(pS[0]-punkty[max][0])/dzielna;
    			ppp[1]=pS[1]-(pS[1]-punkty[max][1])/dzielna;
    		}

		if (f(ppp[0],ppp[1])<wartmax || f(pp[0],pp[1])<wartmax ) {
    			dzielna=2;
    			if (f(ppp[0],ppp[1])<=f(pp[0],pp[1])) {
        			punkty[max][0]=ppp[0];
        			punkty[max][1]=ppp[1];
        		} else {
        			punkty[max][0]=pp[0];
        			punkty[max][1]=pp[1];
        		}
    		} else {
    			for (i = 0 ; i< 3; i++)
       				if (i!=min) {
           				punkty[i][0]=punkty[min][0]+(-punkty[i][0]+punkty[min][0])/2;
           				punkty[i][1]=punkty[min][1]+(-punkty[i][1]+punkty[min][1])/2;
            			}
      			dzielna*=2;
			if (dzielna<0.001)
				dzielna=2;
		}
	} while (1);

	return EXIT_SUCCESS;
}
