#include <math.h>
#include <stdlib.h>
#include <stdio.h>

const double x1 = 11.25;
const double x2 = 11.75;

double fun(double x) {
  	return 2*x*x*x + 1 - pow(2, x);
}

double fun_d(double x) {
	return 6*x*x - pow(2, x)*log(2);
}

int main() {
	double ro;
	double mx1 = x1;
  	double mx2 = x2;
  	double mx3;
	double old;
  	int iter=0;
	
	printf("Podaj zadana dokladnosc: ");
	scanf("%lf", &ro);
	
	do {
		iter++;
    		mx3 = mx2 - fun(mx2)*(mx2-mx1)/(fun(mx2)-fun(mx1));
    		mx1 = mx2;
    		mx2 = mx3;
    	} while (fabs(mx2 - mx1) >= ro);
	printf("Dla metody siecznych:\n wynik: %20.20f\n wartosc funkcji: %20.20f\n liczba iteracji: %d\n liczba operacji: %d\n", mx3, fun(mx3), iter, iter*5);
  	mx1 = x2;
  	iter = 0;
	
	do {
		iter++;
    		mx2 = mx1 - fun(mx1)/fun_d(mx1);
		old = mx1;
		mx1 = mx2;
  	} while (fabs(mx2-old) >= ro);
	printf("Dla metody Newtona:\n wynik: %20.20f\n wartosc funkcji: %20.20f\n liczba iteracji: %d\n liczba operacji: %d\n", mx2, fun(mx2), iter, iter*3);
	
	return EXIT_SUCCESS;
}
